diff --git a/src/backend/commands/vacuumlazy.c b/src/backend/commands/vacuumlazy.c
index 231e92d..f0933a9 100644
--- a/src/backend/commands/vacuumlazy.c
+++ b/src/backend/commands/vacuumlazy.c
@@ -1701,6 +1701,15 @@ lazy_truncate_heap(Relation onerel, LVRelStats *vacrelstats)
 	BlockNumber new_rel_pages;
 	PGRUsage	ru0;
 	int			lock_retry;
+	long		lock_timeout;
+
+	/*
+	 * Use lock_timeout parameter, if set
+	 */
+	if (LockTimeout == 0)
+		lock_timeout = (long) VACUUM_TRUNCATE_LOCK_TIMEOUT;
+	else
+		lock_timeout = LockTimeout * 1000L;
 
 	pg_rusage_init(&ru0);
 
@@ -1733,7 +1742,7 @@ lazy_truncate_heap(Relation onerel, LVRelStats *vacrelstats)
 			 */
 			CHECK_FOR_INTERRUPTS();
 
-			if (++lock_retry > (VACUUM_TRUNCATE_LOCK_TIMEOUT /
+			if (++lock_retry > (lock_timeout /
 								VACUUM_TRUNCATE_LOCK_WAIT_INTERVAL))
 			{
 				/*
